package analyzers

import java.io.{File, FileOutputStream, FileWriter, PrintStream}
import javax.xml.parsers.DocumentBuilderFactory
import javax.xml.transform.TransformerFactory

import util.analyzers.analyzerTypes._
import ast.dsl.{CompInstanceIdent, InstBoolIdent}
import translators.{DSLCircuitGraphTranslator, DSLOpenPSATranslator, DSLToHipHOPSTranslator, DSLToSMVTranslator}
import util.analyzers.{BDDAnalyzer, Z3ExprTranslators}

import scala.xml.dtd.DocType

/**
  * Created by kdelmas on 27/09/17.
  */

/**
  * Base trait for exporter of KCR models to other languages
  */
trait Exporter extends ConfigurationAnalyzer {
  self: Parsing =>
}









