// Generated from ./src/main/java/parsers/dsl/DSL.g4 by ANTLR 4.5.3

package parsers.dsl;
import ast.dsl.*;

import org.antlr.v4.runtime.tree.ParseTreeListener;

/**
 * This interface defines a complete listener for a parse tree produced by
 * {@link DSLParser}.
 */
public interface DSLListener extends ParseTreeListener {
	/**
	 * Enter a parse tree produced by the {@code SystemAlt}
	 * labeled alternative in {@link DSLParser#program}.
	 * @param ctx the parse tree
	 */
	void enterSystemAlt(DSLParser.SystemAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code SystemAlt}
	 * labeled alternative in {@link DSLParser#program}.
	 * @param ctx the parse tree
	 */
	void exitSystemAlt(DSLParser.SystemAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code IdentList2Alt}
	 * labeled alternative in {@link DSLParser#identList2}.
	 * @param ctx the parse tree
	 */
	void enterIdentList2Alt(DSLParser.IdentList2AltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code IdentList2Alt}
	 * labeled alternative in {@link DSLParser#identList2}.
	 * @param ctx the parse tree
	 */
	void exitIdentList2Alt(DSLParser.IdentList2AltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code IdentList1Alt}
	 * labeled alternative in {@link DSLParser#identList1}.
	 * @param ctx the parse tree
	 */
	void enterIdentList1Alt(DSLParser.IdentList1AltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code IdentList1Alt}
	 * labeled alternative in {@link DSLParser#identList1}.
	 * @param ctx the parse tree
	 */
	void exitIdentList1Alt(DSLParser.IdentList1AltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code IdentList0Alt}
	 * labeled alternative in {@link DSLParser#identlist0}.
	 * @param ctx the parse tree
	 */
	void enterIdentList0Alt(DSLParser.IdentList0AltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code IdentList0Alt}
	 * labeled alternative in {@link DSLParser#identlist0}.
	 * @param ctx the parse tree
	 */
	void exitIdentList0Alt(DSLParser.IdentList0AltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code IdentAlt}
	 * labeled alternative in {@link DSLParser#ident}.
	 * @param ctx the parse tree
	 */
	void enterIdentAlt(DSLParser.IdentAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code IdentAlt}
	 * labeled alternative in {@link DSLParser#ident}.
	 * @param ctx the parse tree
	 */
	void exitIdentAlt(DSLParser.IdentAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code PipedIdentAlt}
	 * labeled alternative in {@link DSLParser#ident}.
	 * @param ctx the parse tree
	 */
	void enterPipedIdentAlt(DSLParser.PipedIdentAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code PipedIdentAlt}
	 * labeled alternative in {@link DSLParser#ident}.
	 * @param ctx the parse tree
	 */
	void exitPipedIdentAlt(DSLParser.PipedIdentAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DeclarationIncludeDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void enterDeclarationIncludeDeclAlt(DSLParser.DeclarationIncludeDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DeclarationIncludeDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void exitDeclarationIncludeDeclAlt(DSLParser.DeclarationIncludeDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DeclarationOpenDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void enterDeclarationOpenDeclAlt(DSLParser.DeclarationOpenDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DeclarationOpenDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void exitDeclarationOpenDeclAlt(DSLParser.DeclarationOpenDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DeclarationPackageDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void enterDeclarationPackageDeclAlt(DSLParser.DeclarationPackageDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DeclarationPackageDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void exitDeclarationPackageDeclAlt(DSLParser.DeclarationPackageDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DeclarationTypeDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void enterDeclarationTypeDeclAlt(DSLParser.DeclarationTypeDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DeclarationTypeDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void exitDeclarationTypeDeclAlt(DSLParser.DeclarationTypeDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DeclarationCompDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void enterDeclarationCompDeclAlt(DSLParser.DeclarationCompDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DeclarationCompDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void exitDeclarationCompDeclAlt(DSLParser.DeclarationCompDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DeclarationConfigDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void enterDeclarationConfigDeclAlt(DSLParser.DeclarationConfigDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DeclarationConfigDeclAlt}
	 * labeled alternative in {@link DSLParser#decl}.
	 * @param ctx the parse tree
	 */
	void exitDeclarationConfigDeclAlt(DSLParser.DeclarationConfigDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code IncludeDeclAlt}
	 * labeled alternative in {@link DSLParser#includeDecl}.
	 * @param ctx the parse tree
	 */
	void enterIncludeDeclAlt(DSLParser.IncludeDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code IncludeDeclAlt}
	 * labeled alternative in {@link DSLParser#includeDecl}.
	 * @param ctx the parse tree
	 */
	void exitIncludeDeclAlt(DSLParser.IncludeDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code OpenDeclAlt}
	 * labeled alternative in {@link DSLParser#openDecl}.
	 * @param ctx the parse tree
	 */
	void enterOpenDeclAlt(DSLParser.OpenDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code OpenDeclAlt}
	 * labeled alternative in {@link DSLParser#openDecl}.
	 * @param ctx the parse tree
	 */
	void exitOpenDeclAlt(DSLParser.OpenDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code PkgPath1Alt}
	 * labeled alternative in {@link DSLParser#pkgPath1}.
	 * @param ctx the parse tree
	 */
	void enterPkgPath1Alt(DSLParser.PkgPath1AltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code PkgPath1Alt}
	 * labeled alternative in {@link DSLParser#pkgPath1}.
	 * @param ctx the parse tree
	 */
	void exitPkgPath1Alt(DSLParser.PkgPath1AltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code PkgPathIdentAlt}
	 * labeled alternative in {@link DSLParser#pkgPathIdent}.
	 * @param ctx the parse tree
	 */
	void enterPkgPathIdentAlt(DSLParser.PkgPathIdentAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code PkgPathIdentAlt}
	 * labeled alternative in {@link DSLParser#pkgPathIdent}.
	 * @param ctx the parse tree
	 */
	void exitPkgPathIdentAlt(DSLParser.PkgPathIdentAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code InstPath1Alt}
	 * labeled alternative in {@link DSLParser#instPath1}.
	 * @param ctx the parse tree
	 */
	void enterInstPath1Alt(DSLParser.InstPath1AltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code InstPath1Alt}
	 * labeled alternative in {@link DSLParser#instPath1}.
	 * @param ctx the parse tree
	 */
	void exitInstPath1Alt(DSLParser.InstPath1AltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code InstPathIdentAlt}
	 * labeled alternative in {@link DSLParser#instPathIdent}.
	 * @param ctx the parse tree
	 */
	void enterInstPathIdentAlt(DSLParser.InstPathIdentAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code InstPathIdentAlt}
	 * labeled alternative in {@link DSLParser#instPathIdent}.
	 * @param ctx the parse tree
	 */
	void exitInstPathIdentAlt(DSLParser.InstPathIdentAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code PackageDeclAlt}
	 * labeled alternative in {@link DSLParser#packageDecl}.
	 * @param ctx the parse tree
	 */
	void enterPackageDeclAlt(DSLParser.PackageDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code PackageDeclAlt}
	 * labeled alternative in {@link DSLParser#packageDecl}.
	 * @param ctx the parse tree
	 */
	void exitPackageDeclAlt(DSLParser.PackageDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code privateVisibilityAlt}
	 * labeled alternative in {@link DSLParser#visibility}.
	 * @param ctx the parse tree
	 */
	void enterPrivateVisibilityAlt(DSLParser.PrivateVisibilityAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code privateVisibilityAlt}
	 * labeled alternative in {@link DSLParser#visibility}.
	 * @param ctx the parse tree
	 */
	void exitPrivateVisibilityAlt(DSLParser.PrivateVisibilityAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code publicVisibilityAlt}
	 * labeled alternative in {@link DSLParser#visibility}.
	 * @param ctx the parse tree
	 */
	void enterPublicVisibilityAlt(DSLParser.PublicVisibilityAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code publicVisibilityAlt}
	 * labeled alternative in {@link DSLParser#visibility}.
	 * @param ctx the parse tree
	 */
	void exitPublicVisibilityAlt(DSLParser.PublicVisibilityAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code TypeDeclAlt}
	 * labeled alternative in {@link DSLParser#typeDecl}.
	 * @param ctx the parse tree
	 */
	void enterTypeDeclAlt(DSLParser.TypeDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code TypeDeclAlt}
	 * labeled alternative in {@link DSLParser#typeDecl}.
	 * @param ctx the parse tree
	 */
	void exitTypeDeclAlt(DSLParser.TypeDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code CompDeclAlt}
	 * labeled alternative in {@link DSLParser#compDecl}.
	 * @param ctx the parse tree
	 */
	void enterCompDeclAlt(DSLParser.CompDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code CompDeclAlt}
	 * labeled alternative in {@link DSLParser#compDecl}.
	 * @param ctx the parse tree
	 */
	void exitCompDeclAlt(DSLParser.CompDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code CompBodyAlt}
	 * labeled alternative in {@link DSLParser#compBody}.
	 * @param ctx the parse tree
	 */
	void enterCompBodyAlt(DSLParser.CompBodyAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code CompBodyAlt}
	 * labeled alternative in {@link DSLParser#compBody}.
	 * @param ctx the parse tree
	 */
	void exitCompBodyAlt(DSLParser.CompBodyAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code VarDeclsAlt}
	 * labeled alternative in {@link DSLParser#varDecls}.
	 * @param ctx the parse tree
	 */
	void enterVarDeclsAlt(DSLParser.VarDeclsAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code VarDeclsAlt}
	 * labeled alternative in {@link DSLParser#varDecls}.
	 * @param ctx the parse tree
	 */
	void exitVarDeclsAlt(DSLParser.VarDeclsAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code VarDeclsListAlt}
	 * labeled alternative in {@link DSLParser#varDeclsList}.
	 * @param ctx the parse tree
	 */
	void enterVarDeclsListAlt(DSLParser.VarDeclsListAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code VarDeclsListAlt}
	 * labeled alternative in {@link DSLParser#varDeclsList}.
	 * @param ctx the parse tree
	 */
	void exitVarDeclsListAlt(DSLParser.VarDeclsListAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code ParametersAlt}
	 * labeled alternative in {@link DSLParser#parameters}.
	 * @param ctx the parse tree
	 */
	void enterParametersAlt(DSLParser.ParametersAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code ParametersAlt}
	 * labeled alternative in {@link DSLParser#parameters}.
	 * @param ctx the parse tree
	 */
	void exitParametersAlt(DSLParser.ParametersAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code EvtsBlockAlt}
	 * labeled alternative in {@link DSLParser#evtsBlock}.
	 * @param ctx the parse tree
	 */
	void enterEvtsBlockAlt(DSLParser.EvtsBlockAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code EvtsBlockAlt}
	 * labeled alternative in {@link DSLParser#evtsBlock}.
	 * @param ctx the parse tree
	 */
	void exitEvtsBlockAlt(DSLParser.EvtsBlockAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code LocsBlockAlt}
	 * labeled alternative in {@link DSLParser#locsBlock}.
	 * @param ctx the parse tree
	 */
	void enterLocsBlockAlt(DSLParser.LocsBlockAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code LocsBlockAlt}
	 * labeled alternative in {@link DSLParser#locsBlock}.
	 * @param ctx the parse tree
	 */
	void exitLocsBlockAlt(DSLParser.LocsBlockAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DefsBlockAlt}
	 * labeled alternative in {@link DSLParser#defsBlock}.
	 * @param ctx the parse tree
	 */
	void enterDefsBlockAlt(DSLParser.DefsBlockAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DefsBlockAlt}
	 * labeled alternative in {@link DSLParser#defsBlock}.
	 * @param ctx the parse tree
	 */
	void exitDefsBlockAlt(DSLParser.DefsBlockAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DefListAlt}
	 * labeled alternative in {@link DSLParser#defList}.
	 * @param ctx the parse tree
	 */
	void enterDefListAlt(DSLParser.DefListAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DefListAlt}
	 * labeled alternative in {@link DSLParser#defList}.
	 * @param ctx the parse tree
	 */
	void exitDefListAlt(DSLParser.DefListAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DefinitionSimpleAlt}
	 * labeled alternative in {@link DSLParser#definition}.
	 * @param ctx the parse tree
	 */
	void enterDefinitionSimpleAlt(DSLParser.DefinitionSimpleAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DefinitionSimpleAlt}
	 * labeled alternative in {@link DSLParser#definition}.
	 * @param ctx the parse tree
	 */
	void exitDefinitionSimpleAlt(DSLParser.DefinitionSimpleAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DefinitionCallAlt}
	 * labeled alternative in {@link DSLParser#definition}.
	 * @param ctx the parse tree
	 */
	void enterDefinitionCallAlt(DSLParser.DefinitionCallAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DefinitionCallAlt}
	 * labeled alternative in {@link DSLParser#definition}.
	 * @param ctx the parse tree
	 */
	void exitDefinitionCallAlt(DSLParser.DefinitionCallAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code CallArgsAlt}
	 * labeled alternative in {@link DSLParser#callArgs}.
	 * @param ctx the parse tree
	 */
	void enterCallArgsAlt(DSLParser.CallArgsAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code CallArgsAlt}
	 * labeled alternative in {@link DSLParser#callArgs}.
	 * @param ctx the parse tree
	 */
	void exitCallArgsAlt(DSLParser.CallArgsAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprFlowContainsAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprFlowContainsAlt(DSLParser.BoolExprFlowContainsAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprFlowContainsAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprFlowContainsAlt(DSLParser.BoolExprFlowContainsAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprOrAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprOrAlt(DSLParser.BoolExprOrAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprOrAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprOrAlt(DSLParser.BoolExprOrAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprImpliesAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprImpliesAlt(DSLParser.BoolExprImpliesAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprImpliesAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprImpliesAlt(DSLParser.BoolExprImpliesAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprFlowNeqAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprFlowNeqAlt(DSLParser.BoolExprFlowNeqAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprFlowNeqAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprFlowNeqAlt(DSLParser.BoolExprFlowNeqAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprParenAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprParenAlt(DSLParser.BoolExprParenAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprParenAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprParenAlt(DSLParser.BoolExprParenAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprEquivAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprEquivAlt(DSLParser.BoolExprEquivAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprEquivAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprEquivAlt(DSLParser.BoolExprEquivAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprAndAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprAndAlt(DSLParser.BoolExprAndAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprAndAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprAndAlt(DSLParser.BoolExprAndAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprCountAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprCountAlt(DSLParser.BoolExprCountAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprCountAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprCountAlt(DSLParser.BoolExprCountAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprEvtIdAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprEvtIdAlt(DSLParser.BoolExprEvtIdAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprEvtIdAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprEvtIdAlt(DSLParser.BoolExprEvtIdAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprFlowEqAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprFlowEqAlt(DSLParser.BoolExprFlowEqAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprFlowEqAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprFlowEqAlt(DSLParser.BoolExprFlowEqAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code BoolExprNotAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void enterBoolExprNotAlt(DSLParser.BoolExprNotAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code BoolExprNotAlt}
	 * labeled alternative in {@link DSLParser#boolExpr}.
	 * @param ctx the parse tree
	 */
	void exitBoolExprNotAlt(DSLParser.BoolExprNotAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FlowExprSetInterAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFlowExprSetInterAlt(DSLParser.FlowExprSetInterAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FlowExprSetInterAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFlowExprSetInterAlt(DSLParser.FlowExprSetInterAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FlowExprTypeValueAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFlowExprTypeValueAlt(DSLParser.FlowExprTypeValueAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FlowExprTypeValueAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFlowExprTypeValueAlt(DSLParser.FlowExprTypeValueAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FlowExprFlowEmptyAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFlowExprFlowEmptyAlt(DSLParser.FlowExprFlowEmptyAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FlowExprFlowEmptyAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFlowExprFlowEmptyAlt(DSLParser.FlowExprFlowEmptyAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FlowExprBasicIdAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFlowExprBasicIdAlt(DSLParser.FlowExprBasicIdAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FlowExprBasicIdAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFlowExprBasicIdAlt(DSLParser.FlowExprBasicIdAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FlowExprSetUnionAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFlowExprSetUnionAlt(DSLParser.FlowExprSetUnionAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FlowExprSetUnionAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFlowExprSetUnionAlt(DSLParser.FlowExprSetUnionAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FlowExprIteAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFlowExprIteAlt(DSLParser.FlowExprIteAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FlowExprIteAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFlowExprIteAlt(DSLParser.FlowExprIteAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FlowExprParenAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFlowExprParenAlt(DSLParser.FlowExprParenAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FlowExprParenAlt}
	 * labeled alternative in {@link DSLParser#flowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFlowExprParenAlt(DSLParser.FlowExprParenAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcBoolExprEquivAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcBoolExprEquivAlt(DSLParser.FcBoolExprEquivAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcBoolExprEquivAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcBoolExprEquivAlt(DSLParser.FcBoolExprEquivAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcBoolExprNotAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcBoolExprNotAlt(DSLParser.FcBoolExprNotAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcBoolExprNotAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcBoolExprNotAlt(DSLParser.FcBoolExprNotAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcBoolExprAndAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcBoolExprAndAlt(DSLParser.FcBoolExprAndAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcBoolExprAndAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcBoolExprAndAlt(DSLParser.FcBoolExprAndAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcBoolExprOrAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcBoolExprOrAlt(DSLParser.FcBoolExprOrAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcBoolExprOrAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcBoolExprOrAlt(DSLParser.FcBoolExprOrAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcBoolExprImpliesAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcBoolExprImpliesAlt(DSLParser.FcBoolExprImpliesAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcBoolExprImpliesAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcBoolExprImpliesAlt(DSLParser.FcBoolExprImpliesAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcBoolExprFlowEqAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcBoolExprFlowEqAlt(DSLParser.FcBoolExprFlowEqAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcBoolExprFlowEqAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcBoolExprFlowEqAlt(DSLParser.FcBoolExprFlowEqAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcBoolExprParenAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcBoolExprParenAlt(DSLParser.FcBoolExprParenAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcBoolExprParenAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcBoolExprParenAlt(DSLParser.FcBoolExprParenAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcBoolExprFlowNeqAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcBoolExprFlowNeqAlt(DSLParser.FcBoolExprFlowNeqAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcBoolExprFlowNeqAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcBoolExprFlowNeqAlt(DSLParser.FcBoolExprFlowNeqAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcBoolExprCountAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcBoolExprCountAlt(DSLParser.FcBoolExprCountAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcBoolExprCountAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcBoolExprCountAlt(DSLParser.FcBoolExprCountAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcBoolExprFlowContainsAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcBoolExprFlowContainsAlt(DSLParser.FcBoolExprFlowContainsAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcBoolExprFlowContainsAlt}
	 * labeled alternative in {@link DSLParser#fcBoolExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcBoolExprFlowContainsAlt(DSLParser.FcBoolExprFlowContainsAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcFlowExprIteAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcFlowExprIteAlt(DSLParser.FcFlowExprIteAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcFlowExprIteAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcFlowExprIteAlt(DSLParser.FcFlowExprIteAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcFlowExprParenAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcFlowExprParenAlt(DSLParser.FcFlowExprParenAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcFlowExprParenAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcFlowExprParenAlt(DSLParser.FcFlowExprParenAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcFlowExprSetInterAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcFlowExprSetInterAlt(DSLParser.FcFlowExprSetInterAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcFlowExprSetInterAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcFlowExprSetInterAlt(DSLParser.FcFlowExprSetInterAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcFlowExprInstPathIdentAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcFlowExprInstPathIdentAlt(DSLParser.FcFlowExprInstPathIdentAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcFlowExprInstPathIdentAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcFlowExprInstPathIdentAlt(DSLParser.FcFlowExprInstPathIdentAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcFlowExprSetUnionAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcFlowExprSetUnionAlt(DSLParser.FcFlowExprSetUnionAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcFlowExprSetUnionAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcFlowExprSetUnionAlt(DSLParser.FcFlowExprSetUnionAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcFlowExprFlowEmptyAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcFlowExprFlowEmptyAlt(DSLParser.FcFlowExprFlowEmptyAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcFlowExprFlowEmptyAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcFlowExprFlowEmptyAlt(DSLParser.FcFlowExprFlowEmptyAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code FcFlowExprTypeValueAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void enterFcFlowExprTypeValueAlt(DSLParser.FcFlowExprTypeValueAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code FcFlowExprTypeValueAlt}
	 * labeled alternative in {@link DSLParser#fcFlowExpr}.
	 * @param ctx the parse tree
	 */
	void exitFcFlowExprTypeValueAlt(DSLParser.FcFlowExprTypeValueAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code ConfigDeclAlt}
	 * labeled alternative in {@link DSLParser#configDecl}.
	 * @param ctx the parse tree
	 */
	void enterConfigDeclAlt(DSLParser.ConfigDeclAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code ConfigDeclAlt}
	 * labeled alternative in {@link DSLParser#configDecl}.
	 * @param ctx the parse tree
	 */
	void exitConfigDeclAlt(DSLParser.ConfigDeclAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code DesignsAlt}
	 * labeled alternative in {@link DSLParser#designSpace}.
	 * @param ctx the parse tree
	 */
	void enterDesignsAlt(DSLParser.DesignsAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code DesignsAlt}
	 * labeled alternative in {@link DSLParser#designSpace}.
	 * @param ctx the parse tree
	 */
	void exitDesignsAlt(DSLParser.DesignsAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code SubstitutionAltDefaultFirst}
	 * labeled alternative in {@link DSLParser#substitution}.
	 * @param ctx the parse tree
	 */
	void enterSubstitutionAltDefaultFirst(DSLParser.SubstitutionAltDefaultFirstContext ctx);
	/**
	 * Exit a parse tree produced by the {@code SubstitutionAltDefaultFirst}
	 * labeled alternative in {@link DSLParser#substitution}.
	 * @param ctx the parse tree
	 */
	void exitSubstitutionAltDefaultFirst(DSLParser.SubstitutionAltDefaultFirstContext ctx);
	/**
	 * Enter a parse tree produced by the {@code SubstitutionAltDefaultEnd}
	 * labeled alternative in {@link DSLParser#substitution}.
	 * @param ctx the parse tree
	 */
	void enterSubstitutionAltDefaultEnd(DSLParser.SubstitutionAltDefaultEndContext ctx);
	/**
	 * Exit a parse tree produced by the {@code SubstitutionAltDefaultEnd}
	 * labeled alternative in {@link DSLParser#substitution}.
	 * @param ctx the parse tree
	 */
	void exitSubstitutionAltDefaultEnd(DSLParser.SubstitutionAltDefaultEndContext ctx);
	/**
	 * Enter a parse tree produced by the {@code SubstitutionAltDefualtMiddle}
	 * labeled alternative in {@link DSLParser#substitution}.
	 * @param ctx the parse tree
	 */
	void enterSubstitutionAltDefualtMiddle(DSLParser.SubstitutionAltDefualtMiddleContext ctx);
	/**
	 * Exit a parse tree produced by the {@code SubstitutionAltDefualtMiddle}
	 * labeled alternative in {@link DSLParser#substitution}.
	 * @param ctx the parse tree
	 */
	void exitSubstitutionAltDefualtMiddle(DSLParser.SubstitutionAltDefualtMiddleContext ctx);
	/**
	 * Enter a parse tree produced by the {@code CompAlternativeAlt}
	 * labeled alternative in {@link DSLParser#compAlternative}.
	 * @param ctx the parse tree
	 */
	void enterCompAlternativeAlt(DSLParser.CompAlternativeAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code CompAlternativeAlt}
	 * labeled alternative in {@link DSLParser#compAlternative}.
	 * @param ctx the parse tree
	 */
	void exitCompAlternativeAlt(DSLParser.CompAlternativeAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code LambdaParametersAlt}
	 * labeled alternative in {@link DSLParser#lambdaParameters}.
	 * @param ctx the parse tree
	 */
	void enterLambdaParametersAlt(DSLParser.LambdaParametersAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code LambdaParametersAlt}
	 * labeled alternative in {@link DSLParser#lambdaParameters}.
	 * @param ctx the parse tree
	 */
	void exitLambdaParametersAlt(DSLParser.LambdaParametersAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code LambdaSpecAlt}
	 * labeled alternative in {@link DSLParser#lambdaSpec}.
	 * @param ctx the parse tree
	 */
	void enterLambdaSpecAlt(DSLParser.LambdaSpecAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code LambdaSpecAlt}
	 * labeled alternative in {@link DSLParser#lambdaSpec}.
	 * @param ctx the parse tree
	 */
	void exitLambdaSpecAlt(DSLParser.LambdaSpecAltContext ctx);
	/**
	 * Enter a parse tree produced by the {@code LambdaPointedSpecAlt}
	 * labeled alternative in {@link DSLParser#lambdaSpec}.
	 * @param ctx the parse tree
	 */
	void enterLambdaPointedSpecAlt(DSLParser.LambdaPointedSpecAltContext ctx);
	/**
	 * Exit a parse tree produced by the {@code LambdaPointedSpecAlt}
	 * labeled alternative in {@link DSLParser#lambdaSpec}.
	 * @param ctx the parse tree
	 */
	void exitLambdaPointedSpecAlt(DSLParser.LambdaPointedSpecAltContext ctx);
}