/**
  * Created by kdelmas on 11/04/16.
  */
package translators

import ast.dsl.DSLSymbol
import com.microsoft.z3.{BitVecNum, DatatypeSort, AST => Z3AST, BoolExpr => Z3BoolExpr}

package object translatorsTypes {
  type DSLContextType = scala.collection.mutable.Map[List[Symbol], Z3AST]
  type TupleCacheType = scala.collection.mutable.Map[Symbol, DatatypeSort]
  type BitVecSortCacheType = scala.collection.mutable.Map[PathIdentType, BitVecNum]
  type PathIdentType = List[DSLSymbol]
}
