package analyzers

import util.analyzers.InfNumericTypes.InfInt
import util.analyzers.{CardinalityAnalysis, ExecutionTimes, Phi, Profiler}
import util.analyzers.analyzerTypes.Real

/**
  * Order computation trait
  */
trait CardinalityComputer extends SafetyIndicatorComputer {
  self: Parsing with SMTTranslation =>

  private lazy val caracPhi = new Phi(phi) with CardinalityAnalysis

  lazy val cardinality: InfInt = caracPhi.cardinality
}


