package analyzers

import java.io.File

import translators.DSLToHipHOPSTranslator

/**
  * Trait for HIPHOPS exportation
  */
trait HipHOPSExporter extends Exporter {
  self: Parsing =>

  def exportToHipHOPS(file: File): Unit = DSLToHipHOPSTranslator.translateConfiguration(conf, file)
}
