/** $Id: Utils.scala 1430 2017-10-17 09:16:44Z kdelmas $
  *
  * @author $Author: kdelmas $
  * @date $Date: 2017-10-17 11:16:44 +0200 (mar. 17 oct. 2017) $ 
  **/

package inlining.dsl

import ast.dsl.{DSLSymbol, PipedDSLSymbol}

/** Utility methods. */
object Utils {

  /** Creates a new PipeDSLsymbol by reversing and concatenating the given list of symbols. */
  def mkPipedSym(xs: List[DSLSymbol], sep: String): PipedDSLSymbol = PipedDSLSymbol(Symbol(xs.reverse.map(_.unPiped).mkString("|", sep, "|")))
}
