package ui

import java.io.File

import analyzers._
import util.analyzers.{BDDCutComputation, CutComputationMode, DesignSpaceExplorationMethod, SMTExploration}

/**
  * Created by kdelmas on 16/01/17.
  */

class Config(var mcsMaxSize: Option[Int] = None,
             var printSolutionIn: Option[File] = None,
             var verboseMode: Boolean = false,
             var cutComputationMode: CutComputationMode = BDDCutComputation,
             var explorationMethod: DesignSpaceExplorationMethod = SMTExploration)
