package util.analyzers

import util.analyzers.InfNumericTypes.InfInt

/**
  * compute the cardinality of BDD trigger functions of the component
  */
trait FCardinalityBuild extends ComponentAnalyzer with BDDAnalyzer {
  self: Component with FBDDBuildSMT =>

  import util.analyzers.InfNumericImplicits._

  lazy val fCardField: CharacteristicFun[InfInt] = computeFCard()

  private def computeFCard() = {
    CharacteristicFun[InfInt](fBDDField.func.map(p => (p._1, computeCardBDD(p._2))), POSITIVE_INFINITY)
  }
}
