package util.analyzers

import ast.dsl.InstBoolIdent
import com.microsoft.z3.{Expr => Z3Expr}

case class MonotonyCounterExample(events:Map[InstBoolIdent,(Z3Expr,Z3Expr)]) {
  override def toString: String = s"phi is not monotonic since for ${events.map(kv => kv._1 -> kv._2._1).mkString(",")} " +
    s"phi is true but for ${events.map(kv => kv._1 -> kv._2._2).mkString(",")} phi is false"
}