/** @author rdelmas */
package util.sat

import org.sat4j.specs.{IProblem, ISolver}

// import org.sat4j.core.{VecInt, Vec}
//////////////////////
// import org.sat4j.pb
///////////////////////
// import org.sat4j.specs.{ISolver,IProblem,ISolverService}
/////////////////////////
// import org.sat4j.tools.{ModelIterator,SubModelIterator,SearchListenerAdapter,ClausalCardinalitiesDecorator,DimacsOutputSolver,encoding}
///////////////////////////////////
// import org.sat4j.minisat.core.{ICDCL,RestartStrategy}
/////////////////////

/** A builder for dimacs models. */
abstract class Sat4JSolver(solver: ISolver with IProblem) extends SolverLike with ProblemLike {
  /*
    private var nofVars: Int = 0
    private var nofClauses: Int = 0
    private val clauses: immutable.VectorBuilder[Int] = new immutable.VectorBuilder()

    /** Returns unit since all actions are side effected to the solver given as argument. */
    def result(): Unit =  ()

    def freshVar(): Int = {
      val res = nofVars
      nofVars += 1
      res
    }

    def addClause2( l1: Int, l2: Int ) ( implicit switchable: Boolean = false ): Option[Int] = {
      clauses += l1
      clauses += l2
      clauses += 0
    }

    def addClause3( l1: Int, l2: Int, l3: Int ) ( implicit switchable: Boolean = false ): Option[Int] = {
      clauses += l1
      clauses += l2
      clauses += l3
      clauses += 0
    }

    def addClauseN( lits: List[Int] )( implicit switchable: Boolean = false ): Option[Int] = {
      clauses ++= lits
      clauses += 0
      clauses +=1
    }

    def addAnd( x: Int, l: List[Int] )( implicit switchable: Boolean = false ): Option[Int] = l match {
      case Nil | _ :: Nil => throw new Exception( "found 'AND' node with 0 or 1 kid, formula needs simplification" )
      case l => {
        this.addClauseN( x :: l.map( k => -k ) )
        l.foreach( k => this.addClause2( k, -x ) )
      }
    }

    def addOr( x: Int, l: List[Int] )( implicit switchable: Boolean = false ): Option[Int] = l match {
      case Nil | _ :: Nil => throw new Exception("found 'OR' node with 0 or 1 kid, formula needs simplification" )
      case l => {
        this.addClauseN(-x :: l)
        l.foreach( k => this.addClause2( -k, x ) )
      }
    }

    def addImplies(x: Int, p: Int, q: Int)( implicit switchable: Boolean = false ): Option[Int] = {
      this.addClause3(-p, q, -x)
      this.addClause2( p, x)
      this.addClause2(-q, x)
    }


    def addIff(x: Int, p: Int, q: Int)( implicit switchable: Boolean = false ): Option[Int] = {
      this.addClause3(-p,  q, -x)
      this.addClause3( p, -q, -x)
      this.addClause3(-p, -q,  x)
      this.addClause3( p,  q,  x)
    }

    def addIte(x: Int, s: Int, t: Int, f: Int)( implicit switchable: Boolean = false ): Option[Int] = {
      this.addClause3(-s, -t,  x)
      this.addClause3(-s,  t, -x)
      this.addClause3( s, -f,  x)
      this.addClause3( s,  f, -x)
      this.addClause3(-t, -f,  x)
      this.addClause3( t,  f, -x)
    }

    /** Adds a cardinality constraint {{{ sum(lits) <= k }}}. */
    def addAtMostK( k: Int, lits:List[Int])( implicit switchable: Boolean = false ): Option[Int]

    /** Adds a cardinality constraint {{{ sum(lits) <= k }}}. */
    def addAtLeastK( k: Int, lits:List[Int])( implicit swithchable: Boolean = false ): Option[Int]

    /** Adds a cardinality constraint {{{ sum(lits) <= k }}}. */
    def addExactlyK( k: Int, lits:List[Int])( implicit switchable: Boolean = false ): Option[Int]

    /** Dumps the clause database to a dimacs formatted file. */
    def dumpToFile(filename: String): Option[Int] = {
      // TODO
    }
    */
}
